local onDutyPlayers = {}
local BlipUpdateTime = 1;

--------------
-- COMMANDS --
--------------

RegisterCommand("leoduty", function(source, args, rawCommand)
    local department = tostring(args[1]) 
    local callsign = args[2]
    local isAlreadyOnDuty = false
    for _, player in ipairs(onDutyPlayers) do
        if player.source == source then
            isAlreadyOnDuty = true
            break
        end
    end
    if department == nil then 
        if not isAlreadyOnDuty then 
            TriggerClientEvent('codem-notification', source, "You need to specify a department to go onduty.", 4500, "info", options)
            return
        end 
    end   
    if callsign == nil then 
        if not isAlreadyOnDuty then 
            TriggerClientEvent('codem-notification', source, "You need to specify a callsign to go onduty.", 4500, "info", options)
            return
        end 
    end  
    if isAlreadyOnDuty then
        TriggerEvent("krypton-leo-duty:offDuty", source)
    else
        TriggerEvent("krypton-leo-duty:onDuty", source, department, callsign)
    end
end)

-------------------
-- SERVER EVENTS --
-------------------

RegisterServerEvent('krypton-leo-duty:onDuty')
AddEventHandler('krypton-leo-duty:onDuty', function(source, department, callsign)
    local source = source
    department = string.upper(department)
    callsign = string.upper(callsign)
    local departmentExists = false
    for dep, _ in pairs(Config.departments) do
        if string.upper(dep) == department then
            departmentExists = true
            break
        end
    end
    if not departmentExists then
        TriggerClientEvent('chat:addMessage', source, { args = {'[krypton-leo Duty] Invalid department.'} })
        TriggerClientEvent('codem-notification', source, "You need to specify a callsign to go onduty.", 4500, "info", options)
        return
    end
    local hasPermission = false     
    if Config.departments[department] and Config.departments[department].ace_perm then
        hasPermission = IsPlayerAceAllowed(source, Config.departments[department].ace_perm)
    end
    if hasPermission then
        table.insert(onDutyPlayers, {source = source, time = 0, department = department, callsign = callsign, blip = Config.departments[department].blipColor, category = Config.departments[department].type})
        TriggerClientEvent('codem-notification', source, "You are now onduty as " .. department .. " " .. callsign, 4500, info, options)
        TriggerClientEvent('krypton-leo-hud:UpdateDeptCallsignClient', source, department, callsign)
        TriggerClientEvent('krypton-leo-duty:updateOnDutyPlayers', -1, onDutyPlayers)
        TriggerClientEvent('krypton-leo-duty:enableblips', source, Config.departments[department].type)
        if department == "STAFF" then
            TriggerClientEvent('krypton-leo-duty:ReturnUnitInfo', source, "STAFF")
        end
        if Config.departments[department].type == "LEO" then
            isleo = true
            isfire = true
        else
            isleo = false
        end
        if Config.departments[department].type == "STAFF" then
            isstaff = true
            isleo = true
        else
            isstaff = false
        end
        if Config.departments[department].type == "FIRE" then
            isfire = true
        else
            isfire = false
        end
        if Config.departments[department].type == "PUBLIC" then
            ispublic = true
        else
            ispublic = false
        end 
        unittypetable = {
            isstaff = isstaff,
            isleo = isleo,
            isfire = isfire,
            ispublic = ispublic,
        }
        TriggerClientEvent('krypton-leo-duty:onDuty', source, unittypetable)
        MySQL.Async.execute("INSERT INTO leoactivedutyunits (discord, id, name, dpt, onDutySince) VALUES (@discord, @id, @name, @dpt, @onDutySince)", {
            ['@discord'] = ExtractIdentifiers(source).discord:gsub("discord:", ""),
            ['@id'] = source,
            ['@name'] = GetPlayerName(source),
            ['@dpt'] = department,
            ['@onDutySince'] = os.date("%c", os.time())
        })
    else
        TriggerClientEvent('codem-notification', source, "You do not have permission to go on duty as this department.", 4500, "error", options)
    end
end)

RegisterServerEvent('krypton-leo-duty:offDuty')
AddEventHandler('krypton-leo-duty:offDuty', function(source)
    local source = source
    for i, player in ipairs(onDutyPlayers) do
        if player.source == source then
            local timeOnDuty = player.time
            local identifiers = ExtractIdentifiers(source)
            local discordId = identifiers.discord:gsub("discord:", "")
            local department = player.department
            local callsign = player.callsign
            local departmentConfig = Config.departments[department]
            local departmentLongName = departmentConfig.longName
            local webhookURL = departmentConfig.webHook
            local lastClockin = os.date('%Y-%m-%d %H:%M:%S')
            local description
            
            -- Add the discord mention here
            local discordMention = "<@" .. discordId .. ">"
            
            -- Create the description with the mention
            description = "Discord: " .. discordMention .. "\nTime On Duty: " .. timeOnDuty .. " seconds\nLEO-Identifier: " .. callsign
            
            TriggerClientEvent('codem-notification', source, "You went off duty after " .. timeOnDuty .. " seconds", 4500, info, options)
            local title = "User Went off duty as " .. departmentLongName
            sendToDisc(title, description, "Off Duty Log", webhookURL)
            TriggerClientEvent('krypton-leo-hud:UpdateDeptCallsignClient', source, "Not Onduty", "Not Onduty")
            MySQL.Async.execute('INSERT INTO dutylogs (dept, name, discord_id, time, lastclockin) VALUES (?, ?, ?, ?, ?) ON DUPLICATE KEY UPDATE time = time + VALUES(time), lastclockin = VALUES(lastclockin)', {department, callsign, discordId, timeOnDuty, lastClockin})
            for counter, player in ipairs(onDutyPlayers) do
                if player.source == source then
                    table.remove(onDutyPlayers, counter)  
                end 
            end
            MySQL.Async.execute("DELETE FROM activedutyunits WHERE discord = @discord", {
				['@discord'] = ExtractIdentifiers(source).discord:gsub("discord:", ""),
			})
            TriggerClientEvent('krypton-leo-duty:updateOnDutyPlayers', -1, onDutyPlayers)
            TriggerClientEvent('krypton-leo-duty:disableblips', tonumber(source))
            TriggerClientEvent('krypton-leo-duty:ReturnUnitInfo', source, nil) 
            break
        end
    end
end)

RegisterServerEvent('krypton-leo-duty:TotalOnDutyPlayers')
AddEventHandler('krypton-leo-duty:TotalOnDutyPlayers', function()
    local totalOnDuty = #onDutyPlayers
end)

AddEventHandler('playerDropped', function()
    local source = source

    for i, player in ipairs(onDutyPlayers) do
        if player.source == source then
            local timeOnDuty = player.time
            local identifiers = ExtractIdentifiers(source)
            local discordId = identifiers.discord:gsub("discord:", "")
            local department = player.department
            local callsign = player.callsign
            local departmentConfig = Config.departments[department]
            local departmentLongName = departmentConfig.longName
            local webhookURL = departmentConfig.webHook
            local lastClockin = os.date('%Y-%m-%d %H:%M:%S')
            local description
            
            -- Add the discord mention here
            local discordMention = "<@" .. discordId .. ">"
            
            -- Create the description with the mention
            description = "Discord: " .. discordMention .. "\nTime On Duty: " .. timeOnDuty .. " seconds\nLEO-Identifier: " .. callsign
            
            local title = "User Went off duty as " .. departmentLongName
            sendToDisc(title, description, "Off Duty Log", webhookURL)
            MySQL.Async.execute('INSERT INTO leodutylogs (dept, name, id, time, lastclockin) VALUES (?, ?, ?, ?, ?) ON DUPLICATE KEY UPDATE time = time + VALUES(time), lastclockin = VALUES(lastclockin)', {department, callsign, discordId, timeOnDuty, lastClockin})
            table.remove(onDutyPlayers, i)
            MySQL.Async.execute("DELETE FROM leoactivedutyunits WHERE discord = @discord", {
				['@discord'] = ExtractIdentifiers(source).discord:gsub("discord:", "")
			})
            TriggerClientEvent('krypton-leo-duty:updateOnDutyPlayers', -1, onDutyPlayers)
            TriggerClientEvent('krypton-leo-duty:offDuty', source)
            TriggerClientEvent('krypton-leo-duty:ReturnUnitInfo', source, nil) 
            break
        end
    end
end)

-------------
-- THREADS --
-------------

CreateThread(function()
    while true do
        Citizen.Wait(1000) -- 1 Second in ms
        for _, player in ipairs(onDutyPlayers) do
            player.time = player.time + 1
        end
    end
end)

CreateThread(function()
    while true do
        Wait(1000)
        local list = {}
        for id,info in pairs(onDutyPlayers) do
            if GetPlayerPed(info.source) then
                local coordsForONDP = GetEntityCoords(GetPlayerPed(info.source))
                table.insert(list, {
                    ['svid'] = info.source,
                    ['x'] = coordsForONDP.x,
                    ['y'] = coordsForONDP.y,
                    ['z'] = coordsForONDP.z,
                    ['name'] = '['..info.callsign..'] '..GetPlayerName(info.source),
                    ['hdg'] = math.floor(tonumber(GetEntityHeading(GetPlayerPed(info.source)))),
                    ['color'] = info.blip,
                    ['category'] = info.category
                })
            end
        end
        for id,info in pairs(onDutyPlayers) do
            TriggerClientEvent('krypton-leo-duty:updateblips', tonumber(info.source), list)
        end
    end
end)

---------------
-- FUNCTIONS -- 
---------------


function ExtractIdentifiers(src)
    local identifiers = {
        steam = "",
        ip = "",
        discord = "",
        license = "",
        xbl = "",
        live = ""
    }
    for i = 0, GetNumPlayerIdentifiers(src) - 1 do
        local id = GetPlayerIdentifier(src, i)
        if string.find(id, "steam") then
            identifiers.steam = id
        elseif string.find(id, "ip") then
            identifiers.ip = id
        elseif string.find(id, "discord") then
            identifiers.discord = id
        elseif string.find(id, "license") then
            identifiers.license = id
        elseif string.find(id, "xbl") then
            identifiers.xbl = id
        elseif string.find(id, "live") then
            identifiers.live = id
        end
    end
    return identifiers
end

function sendToDisc(title, message, footer, webhookURL)
	local embed = {}
	embed = {{
        ['color'] = 16711680, -- Red color for embed
        ['title'] = '**' .. title .. '**',
        ['description'] = message,
        ['thumbnail'] = { ['url'] = 'https://media.discordapp.net/attachments/1278443738431230038/1317245865987145810/US_Department_of_State_1.png?ex=675ea50f&is=675d538f&hm=61713b7f13811a489eff39d3c9d26a22dae6d3059b431623e0d8e41458a8f8dc&=&format=webp&quality=lossless&width=275&height=275' }, -- GIF image URL
        ['footer'] = { ['text'] = '[krypton-leo LEO Duty] Thank you so much for your dedicated service and for helping to keep the law and order in our Florida community, Your hard work has not gone unnoticed!' }
    }}
	PerformHttpRequest(webhookURL, function(err, text, headers) end, 'POST', json.encode({username = name, embeds = embed}), {['Content-Type'] = 'application/json'})
end

function IsOnDuty(source)
    local IsOnDuty = false
    for _, player in ipairs(onDutyPlayers) do
        if player.source == source then
            IsOnDuty = true
            break
        end
    end
end

function IsOnDutyStaff(source)
    local IsOnDutyStaff = false 
    local isPlayerOnDuty = false
    for _, player in ipairs(onDutyPlayers) do 
        if player.source == source then
            isPlayerOnDuty = true
            local playerDept = player.department
            if Config.departments[playerDept].type == "STAFF" then
                IsOnDutyStaff = true 
                break
            end
        end
    end
    if not isPlayerOnDuty then
        IsOnDutyStaff = false
    end
    return IsOnDutyStaff
end