<?php
session_start();
include('db.php');

// Check if the user is logged in and has admin privileges
if (!isset($_SESSION['user']) || $_SESSION['user']['role'] !== 'admin') {
    header('Location: login.php');
    exit;
}

if (isset($_POST['submit_ip'])) {
    // Get the form data
    $ip_address = $_POST['ip_address'];
    $script_name = $_POST['script_name'];

    // Validate the IP address format (basic validation)
    if (!filter_var($ip_address, FILTER_VALIDATE_IP)) {
        echo "<script>alert('Invalid IP address format.'); window.location.href = 'index.php';</script>";
        exit;
    }

    // Prepare the SQL query to insert the new IP into the whitelist
    $stmt = $pdo->prepare("INSERT INTO whitelist_ips (ip_address, script_name, added_on) VALUES (:ip_address, :script_name, NOW())");
    $stmt->bindParam(':ip_address', $ip_address);
    $stmt->bindParam(':script_name', $script_name);

    // Execute the query
    if ($stmt->execute()) {
        echo "<script>alert('IP added to the whitelist successfully!'); window.location.href = 'index.php';</script>";
    } else {
        echo "<script>alert('Failed to add IP to the whitelist. Please try again.'); window.location.href = 'index.php';</script>";
    }
}
?>
