<?php
include('admin-actions.php'); // Include the actions file that handles all the logic

// Check if the user is an admin
if (!isset($_SESSION['user']) || $_SESSION['user']['role'] != 'admin') {
    header('Location: login.php');
    exit;
}

include('header.php'); // Include header with the necessary styling and navigation
?>

<!-- Page Header with Royal Development Branding -->
<div class="page-header">
    <h1>Welcome to the FiveM IP Whitelist Panel</h1>
    <p class="royal-logo">Powered by Royal Development</p>
</div>

<!-- Admin Features -->
<?php if ($is_admin): ?>

    <!-- Assign Product to User and Whitelist IP -->
    <div class="card">
        <div class="card-body">
            <h4 class="card-title text-center">Assign Product to User & Whitelist IP</h4>
            <form method="POST">
                <div class="mb-3">
                    <label for="user_id" class="form-label">Select User</label>
                    <select class="form-control" id="user_id" name="user_id" required>
                        <?php foreach ($users as $u): ?>
                            <option value="<?php echo $u['id']; ?>"><?php echo $u['username']; ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div class="mb-3">
                    <label for="product_id" class="form-label">Select Product</label>
                    <select class="form-control" id="product_id" name="product_id" required>
                        <?php foreach ($products as $p): ?>
                            <option value="<?php echo $p['id']; ?>"><?php echo $p['name']; ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div class="mb-3">
                    <label for="ip_address" class="form-label">User IP Address</label>
                    <input type="text" class="form-control" id="ip_address" name="ip_address" required>
                </div>
                <button type="submit" name="assign_product" class="btn btn-primary w-100">Assign Product & Whitelist IP</button>
            </form>
        </div>
    </div>

    <!-- View All Users and Their Assigned Products -->
    <div class="card">
        <div class="card-body">
            <h4 class="card-title text-center">All Users and Their Assigned Products</h4>
            <table class="table table-bordered table-striped">
                <thead>
                    <tr>
                        <th>User</th>
                        <th>Assigned Products</th>
                        <th>Actions</th>
                    </tr>
                </thead>
                <tbody>
                    <?php foreach ($user_product_data as $row): ?>
                        <tr>
                            <td><strong><?php echo $row['username']; ?></strong></td>
                            <td><?php echo $row['product_name']; ?></td>
                            <td>
                                <form method="POST" style="display:inline;">
                                    <input type="hidden" name="user_id" value="<?php echo $row['id']; ?>">
                                    <input type="hidden" name="product_id" value="<?php echo $row['product_id']; ?>">
                                    <button type="submit" name="remove_product" class="btn btn-danger btn-sm">Remove Product</button>
                                </form>
                            </td>
                        </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        </div>
    </div>

<?php endif; ?>

<?php include('footer.php'); ?> <!-- Include footer -->
