<?php
session_start();
include('../db.php');

// Check if the user is logged in
if (!isset($_SESSION['user'])) {
    header('Location: ../login.php');
    exit;
}

$user = $_SESSION['user'];
$user_id = $user['id'];

// Fetch the products assigned to this user
$stmt = $pdo->prepare("SELECT products.name, products.description, products.file_path 
                       FROM products 
                       JOIN user_products ON products.id = user_products.product_id
                       WHERE user_products.user_id = :user_id");
$stmt->bindParam(':user_id', $user_id);
$stmt->execute();
$assigned_products = $stmt->fetchAll();

include('../header.php');
?>

<!-- User Panel: Assigned Products -->
<h3>Your Assigned Products</h3>
<?php if (count($assigned_products) > 0): ?>
    <?php foreach ($assigned_products as $product): ?>
        <div class="card">
            <div class="card-body">
                <h5><?php echo $product['name']; ?></h5>
                <p><?php echo $product['description']; ?></p>
                <a href="<?php echo $product['file_path']; ?>" download class="btn btn-info">Download</a>
            </div>
        </div>
    <?php endforeach; ?>
<?php else: ?>
    <p>You have no assigned products.</p>
<?php endif; ?>

<?php include('../footer.php'); ?>
